module Obake
  class FiniteStateMachine
    attr_reader :current_state
    
    def initialize
      @states = {}
    end
    
    def add_state(state)
      state.instance_variable_set(:@fsm, self)
      @states[state.id] = state
    end
    
    def change_state(transition)
      if @current_state
        @current_state.on_exit
      end

      @current_state = @states[transition.to]

      @current_state.on_enter(transition.data)
    end
  end
end
